POJ1417:True Liars(DP+带权并查集)

True Liars

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 16338    Accepted Submission(s): 5724

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=3038

Description:

After having drifted about in a small boat for a couple of days, Akira Crusoe Maeda was finally cast ashore on a foggy island. Though he was exhausted and despaired, he was still fortunate to remember a legend of the foggy island, which he had heard from patriarchs in his childhood. This must be the island in the legend. In the legend, two tribes have inhabited the island, one is divine and the other is devilish, once members of the divine tribe bless you, your future is bright and promising, and your soul will eventually go to Heaven, in contrast, once members of the devilish tribe curse you, your future is bleak and hopeless, and your soul will eventually fall down to Hell.

In order to prevent the worst-case scenario, Akira should distinguish the devilish from the divine. But how? They looked exactly alike and he could not distinguish one from the other solely by their appearances. He still had his last hope, however. The members of the divine tribe are truth-tellers, that is, they always tell the truth and those of the devilish tribe are liars, that is, they always tell a lie.

He asked some of them whether or not some are divine. They knew one another very much and always responded to him "faithfully" according to their individual natures (i.e., they always tell the truth or always a lie). He did not dare to ask any other forms of questions, since the legend says that a devilish member would curse a person forever when he did not like the question. He had another piece of useful informationf the legend tells the populations of both tribes. These numbers in the legend are trustworthy since everyone living on this island is immortal and none have ever been born at least these millennia.

You are a good computer programmer and so requested to help Akira by writing a program that classifies the inhabitants according to their answers to his inquiries.

Input:

The input consists of multiple data sets, each in the following format :

n p1 p2
xl yl a1
x2 y2 a2
...
xi yi ai
...
xn yn an

The first line has three non-negative integers n, p1, and p2. n is the number of questions Akira asked. pl and p2 are the populations of the divine and devilish tribes, respectively, in the legend. Each of the following n lines has two integers xi, yi and one word ai. xi and yi are the identification numbers of inhabitants, each of which is between 1 and p1 + p2, inclusive. ai is either yes, if the inhabitant xi said that the inhabitant yi was a member of the divine tribe, or no, otherwise. Note that xi and yi can be the same number since "are you a member of the divine tribe?" is a valid question. Note also that two lines may have the same x's and y's since Akira was very upset and might have asked the same question to the same one more than once.

You may assume that n is less than 1000 and that p1 and p2 are less than 300. A line with three zeros, i.e., 0 0 0, represents the end of the input. You can assume that each data set is consistent and no contradictory answers are included.

Output:

For each data set, if it includes sufficient information to classify all the inhabitants, print the identification numbers of all the divine ones in ascending order, one in a line. In addition, following the output numbers, print end in a line. Otherwise, i.e., if a given data set does not include sufficient information to identify all the divine members, print no in a line.

Sample Input:

2 1 1
1 2 no
2 1 no
3 2 1
1 1 yes
2 2 yes
3 3 yes
2 2 1
1 2 yes
2 3 no
5 4 3
1 2 yes
1 3 no
4 5 yes
5 6 yes
6 7 no
0 0 0

Sample Output:

no
no
1
2
end
3
4
5
6
end

题意:

给出p1个好人,p2个坏人,这里面好人只说真话,坏人只说假话。

然后会有回答x y yes/no,代表的意思是x说y是好人/坏人。

最后就问你能否通过这些回答判断出哪些是好人(个数等于p1)并且输出。

题解:

这题我当时只是把思路想出来了,最后代码的实现并没有独立完成,主要是代码的后半部分...

我们先分析题目,假定x说y是好人,那么现在x有两种情况(好/坏),根据这两种情况也可以确定出y的好坏;同理,如果x说y是坏人,也有两种情况。通过对这两种情况的分析,我们会发现,当x说y是好人是,他们是同类的;当x说y是坏人时,他们不是同类的。

根据这个我们可以想到带权的并查集,用数组v[x]代表x与其父节点的关系,当v[x]为0时x与其父亲同类,为1时不同类。由于这是一个环状的关系,所以会模2。

假定我们已经分好了类,那么就会有n个集合,每个集合有与父节点同类的,也有不同类的。

如果我们现在要确定出好人的数量,那么在每个集合里面只能选一种,这时就用dp来处理:设dp[i,j]的含义是处理到第i个集合时,和为j的方案总数。

那么初始化dp[0,0]=1,转移方程为dp[i,j]+=dp[i-1,j-k0,k1],k0,k1为i集合中的两类的数量。

最后输出路径的时候有许多种方法,有兴趣的可以看下其它的代码~

最后注意,如果p1等于0,也会输出一个end。我就是在这里被坑了好久。

具体代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
using namespace std;

const int N = 1505 ;    
int n,p1,p2,cnt;
int f[N],dp[N][N],v[N],g[N],set[N][5];

int find(int x){
    if(f[x]==x) return x;
    int tmp = f[x];
    f[x]=find(f[x]);
    v[x]=(v[x]+v[tmp])%2;
    return f[x];
}

int main(){
    while(~scanf("%d%d%d",&n,&p1,&p2)){
        if(!n && !p1 &&!p2) break;
        cnt = 0;memset(set,0,sizeof(set));memset(dp,0,sizeof(dp)); 
        memset(f,-1,sizeof(f));
        for(int i=1;i<=p1+p2;i++) f[i]=i,v[i]=0;
        char s[10];int x,y;
        for(int k=1;k<=n;k++){
            scanf("%d%d %s",&x,&y,s);
            int fx=find(x),fy=find(y);
            if(fx==fy) continue ;
            f[fx]=fy;
            if(s[0]=='y') v[fx]=(v[x]+v[y])%2;
            else v[fx]=(v[x]+v[y]+1)%2;
        }
        for(int i=1;i<=p1+p2;i++){
            if(find(i)==i) g[i]=++cnt;
        }
        for(int i=1;i<=p1+p2;i++) set[g[find(i)]][v[i]]++;//set数组记录第几组两类的个数 
        dp[0][0]=1;//dp[i,j]前i个集合,和为j的情况数量 
        for(int i=1;i<=cnt;i++){
            for(int j=0;j<=p1;j++){  //注意p1等于0的情况 
                if(j>=set[i][0]) dp[i][j]+=dp[i-1][j-set[i][0]]; 
                if(j>=set[i][1]) dp[i][j]+=dp[i-1][j-set[i][1]];
            }
        } 
        int tmp = p1;
        int choose[N];
        memset(choose,-1,sizeof(choose));
        if(dp[cnt][p1]==1){
            for(int i=cnt;i>=1;i--){
                if(dp[i-1][tmp-set[i][0]]==dp[i][tmp]){
                    choose[i]=0;
                    tmp-=set[i][0];
                }else if(dp[i-1][tmp-set[i][1]]==dp[i][tmp]){
                    choose[i]=1;
                    tmp-=set[i][1];
                }
            }
            for(int i=1;i<=p1+p2;i++){
                if(choose[g[find(i)]]==v[i]) printf("%d\n",i);
            }
            puts("end");
        }else puts("no");
    }
    return 0;
}
/*
2 0 2
1 2 yes
2 1 yes 
*/ 

猜你喜欢

转载自www.cnblogs.com/heyuhhh/p/9998670.html